function vals = argmax(f)
% ARGMAX     Computes the most likely arguments of a table factor
%
%    VALS = ARGMAX(FACTOR) returns a vector of values s.t. FACTOR
%    is maximal when FACTOR.vars == VALS.
%

maxvalue = f.table;

for i=length(f.vars):-1:1
  maxvalue = max(maxvalue, [], i);
end

index = find(f.table==maxvalue, 1);

[vals{1:length(f.vars)}] = ind2sub(size(f.table),index);
vals = cell2mat(vals);
