%clc;
fprintf('\n----------------------------------------------\n');
NTrainV = [100]; %10:10:90, 100:100:1000];
Prec = [];  XVal = [];
for i = 1:length(NTrainV)
  StartTm = cputime;
  EmPrec = baumWelch1(table, 100, NTrainV(i), 100);
  if i == 1
    Prec.Labeled(1) = EmPrec.Labeled(1);
    Prec.Train(1) = EmPrec.Train(1);
    Prec.Test(1) = EmPrec.Test(1);
    XVal = [1];
  end
  Prec.Labeled(i+1) = EmPrec.Labeled(end);
  Prec.Train(i+1) = EmPrec.Train(end);
  Prec.Test(i+1) = EmPrec.Test(end);
  XVal = [XVal; NTrainV(i)];
  save Prec.mat Prec
  figure(1)
  clf; hold on
  plot(XVal, Prec.Labeled, 'r-s');
  plot(XVal, Prec.Train, 'b-o');
  plot(XVal, Prec.Test, 'k-d');
  xlabel('unlabeled data');  ylabel('precision');
  legend('labeled', 'train', 'test');
  hold off
  saveas(gca, 'prec_BW1-100.eps', 'psc2');
  fprintf('***RUN TIME %f min\n\n', (cputime-StartTm)/60);
end