function g = collapse(f, domain, operator)
% MAXIMUM     Collapses a table factor
%
%    NEW_FACTOR = COLLAPSE(FACTOR, DOMAIN, OPERATOR) applies the operator
%    to all the arguments of factor other than DOMAIN.  OPERATOR is
%    a name/handle of a function that takes a table as an input and
%    dimension and returns a new table of the same size but the
%    given dimension collapsed.
%
%    See also: maximum, marginal

%assert(length(f.vars)<=2);
%assert(length(domain)==1);

vars=f.vars;

if isempty(domain)
  g.vars=[];
  g.table=feval(operator,feval(operator,f.table,1),2);
elseif vars(1)==domain
  g.vars=domain;
  g.table=feval(operator,f.table,2);
elseif vars(2)==domain
  g.vars=domain;
  g.table=feval(operator,f.table,1)';
else
  error('Wrong domain');
end
