function counts=get_counts(table)
% GET_COUNTS	Gets the pseudo counts for prior and the transitions
%
%    TABLE is a set of *labeled* training examples
%    COUNTS is a structure (same as HMM model) with the only
%    difference that it contains counts instead of probabilities
%


% prior
id = find(table(:,3)==-1);
n = length(id);
for i=1:26,
  prior(i,1)=sum(table(id,2)==i);
end
counts.prior= prior;

% transition model
for i=1:26,
  id = find(table(:,3)==i);
  n = length(id);
  for j=1:26,
    transition(i,j) = sum(table(id,2)==j);
  end
end
counts.transition= transition;

% observation model
for i=1:26,
  id = find(table(:,2)==i);
  n = length(id);
  for j=0:1,
    observation(i,:,j+1) = sum(table(id,7:end)==j);
  end
end

nobs = size(table,2)-6;
observation=permute(observation,[1 3 2]);
for k=1:nobs,
  counts.obs(k).table = observation(:,:,k);
end
