function obs = get_obsprob(table, model)
% GET_OBSPROB   Computes the observation likelihoods
% 
%    TABLE is a set of training examples (words, letters)
%    MODEL is a structure describing HMM model
%    OBS are the observation likelihoods
%


nobs = size(table,2)-6;

% Compute the observation likelihoods
subtable = table; %table(get_letters(table, wordid), :);
for j=1:size(subtable,1),
  tmp=ones(26,1);
  for k=1:nobs,
    tmp=tmp .* model.obs(k).table(:, subtable(j,6+k)+1);
  end
  obs(j).vars=j;
  SumTmp = sum(tmp);
  obs(j).table=tmp;
end