function prec = hmm_eval(Table, Model);
% HMM_EVAL	Evalues the model on a set of words from Table using Model
%
%    TABLE is a set of *labeled* examples
%    MODEL is a structure describing HMM model
%    PREC is the precision of the model 
%    (percentage of correct word lables)
%
  WordIdV = unique(Table(:, 4));  
  for w = 1:length(WordIdV) 
    WordTable = Table(get_letters(Table, WordIdV(w)), :);
    truth = WordTable(:,2)';
    hmm = hmm_viterbi(Model.prior, Model.transition, get_obsprob(WordTable, Model));
    precV(w) = sum(truth==hmm) / length(hmm);
  end
  prec = mean(precV);