function model=hmm_init(table)
% HMM_INIT	Innitializes the model with random parameters
%    Prior and transition probabilities are be initialized
%    to random. Observation probabilities are we true (estimated 
%    from the data).
%
%    TABLE is a set of *labeled* training examples
%    MODEL is a structure describing HMM model
%
 

% random prior
RndProb = rand(26, 1);
model.prior=table_factor(1, RndProb/sum(RndProb));

% random transition model
transition = rand(26, 26);
for i=1:26,
  transition(i,:) = transition(i,:) ./ sum(transition(i,:));
end
model.transition=table_factor([1 2],transition);

% random observation model
% nobs = 64;
% for k=1:nobs,
%   r = rand(26, 1);
%   model.obs(k)=table_factor([1 -k], [r, 1-r]);  
% end
trueModel = hmm_train(table);
model.obs = trueModel.obs;

