function model=hmm_train(table)
% HMM_TRAIN	Trains HMM model on labeled data
%
%    TABLE is a set of *labeled* training examples
%    MODEL is a structure describing HMM model
%


% prior
id = find(table(:,3)==-1);
n = length(id);
for i=1:26,
  if n == 0, prior(i,1) = 0;
  else, prior(i,1)=sum(table(id,2)==i)/n; end
end
model.prior=table_factor(1,prior);

% transition model
for i=1:26,
  id = find(table(:,3)==i);
  n = length(id);
  for j=1:26,
    if n == 0, transition(i,j) = 0;
    else, transition(i,j) = sum(table(id,2)==j)/n; end
  end
end
model.transition=table_factor([1 2],transition);

% observation model
for i=1:26,
  id = find(table(:,2)==i);
  n = length(id);
  for j=0:1,
    if n == 0, observation(i,:,j+1) = 0;
    elseif n == 1, observation(i,:,j+1) = table(id,7:end)==j;
    else, observation(i,:,j+1) = sum(table(id,7:end)==j)/(n); end
  end
end
nobs = size(table,2)-6;
observation=permute(observation,[1 3 2]);
for k=1:nobs,
  model.obs(k)=table_factor([1 -k],observation(:,:,k));  
end
