function mpe=hmm_viterbi(prior, transition, obs)
% HMM_VITERBI	Viterbi decoding
%
%    PRIOR is HMM model prior
%    TRANSITON are HMM model transition probabilties
%    OBS are the data observation likelihoods
%
%    MPE is the most likely sequence of hidden states (letters)
%

n = length(obs);

% Forward pass
alpha(1)=multiply(prior, obs(1));
for i=2:n
  transition.vars=[i-1 i];
  factor(i) = multiply(alpha(i-1), transition);
  factor(i) = multiply(factor(i), obs(i));
  alpha(i) = maximum(factor(i), i);
end

% Backward pass
mpe(n) = argmax(alpha(n));
for i=n:-1:2,
  mpe(i-1)=argmax(restrict(factor(i),assignment(i,mpe(i))));
end

% Sanity checks
% for i=1:n,
%   assert(alpha(i).vars==i);
% end
% 
% for i=2:n,
%   assert(factor(i).vars==[i-1 i]);
% end
