function g = restrict(f, a)
% RESTRICT     Restricts a table factor to an assignment
%
%    NEW_FACTOR = RESTRICT(FACTOR, ASSIGNMENT)  Returns a new
%    factor, in which the arguments ASSIGNMENT.vars are fixed
%    to ASSIGNMENT.vals.
%

%assert(length(f.vars)<=2);
%assert(length(a.vars)==1);

vars = f.vars;
var = a.vars;
val = a.vals;

if vars(1)==var
  g.vars=f.vars(2:end);
  g.table=f.table(val,:)';
elseif length(vars)==2 && vars(2)==var
  g.vars=f.vars(1);
  g.table=f.table(:,val);
else
  error('Wrong variable');
end
