function [labeled, train, test] = split_data(table, trainWords);
% SPLIT_DATA    splits the data into 3 sets
%
%    TRAINWORDS is a number of words in TRAIN set
%    LABELED is a table of labeled examples. You will use them to get the 
%    pseudo-counts.
%    TRAIN is a set of unlabeled example (labeled examples but you must not
%    use the labels. You will use this data to run Baum-Welch.
%    TEST is a set of test examples that you will use to evaluate the model
%
  WordIdV = unique(table(:, 4));
  Perm = randperm(length(WordIdV));
  %load('perm.mat');
  %save xxx_LastPerm.mat Perm
  WordIdV = WordIdV(Perm);
  Words = length(WordIdV);
  words = 100;
  labeled = get_table(table, WordIdV(1 : words));
  test = get_table(table, WordIdV(words : 2*words));
  train = get_table(table, WordIdV(2*words : 2*words+trainWords));
  